pdfMake.fonts = {
    Roboto: {
        normal: 'Roboto-Regular.ttf',
        bold: 'Roboto-Medium.ttf',
        italics: 'Roboto-Italic.ttf',
        bolditalics: 'Roboto-Italic.ttf'
    },
    china: {
        normal: 'China-Normal.ttf',
        bold: 'China-Bold.ttf',
        italics: 'China-Normal.ttf',
        bolditalics: 'China-Bold.ttf',
    },
    special: {
        normal: 'Special.ttf',
        bold: 'Special.ttf',
        italics: 'Special.ttf',
        bolditalics: 'Special.ttf',
    }
};

$(document).ready(function () {
    RICHEditor.defalutWindowHeight = document.documentElement.clientHeight || document.body.clientHeight;
    RICHEditor.windowHeight = RICHEditor.defalutWindowHeight;
    var minHeight = localStorage.getItem("min-height");
    RICHEditor.defalutWindowHeight = RICHEditor.defalutWindowHeight >= 300 ? RICHEditor.defalutWindowHeight : (minHeight && minHeight >= 300 ? minHeight : 500);
    RICHEditor.visuTop = 0;
    RICHEditor.visuBottom = RICHEditor.windowHeight;
    $('#editor').css("min-height", parseInt(RICHEditor.defalutWindowHeight));
    localStorage.setItem("min-height",RICHEditor.defalutWindowHeight);
    RICHEditor.editor.focus();
    RICHEditor.enabledEditingItems();
    RICHEditor.setPlaceholder('欢迎使用碎米文档');
    RICHEditor.editor.addEventListener('cursor', function (event) {
        RICHEditor.enabledEditingItems();
        RICHEditor.placeholder();
        RICHEditor.cursorTop = event.range.endContainer.offsetTop;
        if (event.range.endContainer.offsetHeight) {
           RICHEditor.offsetHeight = event.range.endContainer.offsetHeight;
        }
        var windowHeight = document.documentElement.clientHeight || document.body.clientHeight;
//        if (windowHeight < RICHEditor.windowHeight) {
//            $('#editor').css("min-height", windowHeight);
//        }

        RICHEditor.windowHeight = windowHeight;
        RICHEditor.visuTop = document.documentElement.scrollTop || document.body.scrollTop;
        RICHEditor.visuBottom = RICHEditor.visuTop + RICHEditor.windowHeight;
        if ((RICHEditor.cursorTop + RICHEditor.offsetHeight + RICHEditor.cursorHeight) > RICHEditor.visuBottom) {
            $('body,html').animate({
                scrollTop: RICHEditor.cursorTop + RICHEditor.offsetHeight + RICHEditor.cursorHeight - RICHEditor.windowHeight
            }, 0);
        }

        var top = RICHEditor.editor.getCursorPosition().top;
        if (top < 30) {
            $('body,html').animate({
                scrollTop: RICHEditor.visuTop - 30 + top
            }, 0);
        }
         touch(event);
    });
    RICHEditor.editor.addEventListener('touchend', touch);
    RICHEditor.editor.addEventListener('touchstart', touch);
    RICHEditor.editor.addEventListener('click', touch);
    RICHEditor.editor.addEventListener('keyup', touch);
});

function touch(event) {
    var event = event || window.event;
       if (event.target) {
           if (event.target.nodeName.toUpperCase() === 'IMG') {
               if (event.type === 'touchstart') {
                   if (event.target.id.indexOf("img-") > -1) {
                       RICHEditor.imgId = event.target.id;
                   }
                   $("#editor").attr("contentEditable", false);
               } else if (event.type === 'touchend') {
                   RICHEditor.setEditable();
               } else if (event.type === 'click') {
                   RICHEditor.imgClick(event.target);
               }
           } else if (event.target.nodeName.toUpperCase() === 'LI') {
               if (event.type === 'click') {
                   if (event.target.parentNode.nodeName.toUpperCase() === 'UL' &&
                       event.target.parentNode.className.toUpperCase() === 'CUSTOM-ORDER-UL' &&
                       event.x < RICHEditor.orderClickX) {
                       if (!event.target.style.color) {
                           event.target.style.color = RICHEditor.orderSelectedColor;
                           event.target.style.backgroundImage = 'url(static/images/note_edit_render_check.png)';
                       } else {
                           event.target.style.color = '';
                           event.target.style.backgroundImage = '';
                       }
                   }
               }
           }
       }

       if (event.type === 'keyup') {
           RICHEditor.keyCode = event.keyCode;
       } else if (event.type === 'cursor') {
            if (RICHEditor.TAG === 'TODO'&& event.range &&
                event.range.endContainer) {
                nodeTODO(event.range.endContainer);
            }
            if (RICHEditor.keyCode === 13 && event.range &&
               event.range.endContainer && event.range.endContainer.nodeName.toUpperCase() === 'LI' && RICHEditor.TAG === "") {
               event.range.endContainer.style.color = "";
               event.range.endContainer.style.backgroundImage = '';
            }
            RICHEditor.TAG = "";
       }
}

function nodeTODO(node) {
    if (node.nodeName.toUpperCase() === 'LI' && node.parentNode &&
        node.parentNode.nodeName.toUpperCase() === 'UL') {
        node.parentNode.className = 'custom-order-ul';
    } else {
        if (node.parentNode) {
            nodeTODO(node.parentNode)
        }
    }
}

var RICHEditor = {};
RICHEditor.offsetHeight = 30;
RICHEditor.cursorHeight = 16;
RICHEditor.orderSelectedColor = "#AAAAAA"; // 复选框选中颜色
RICHEditor.orderClickX = 32; //复选框点击的最大X组
RICHEditor.keyCode = -1;  //时时记录键盘事件
RICHEditor.TAG = "";
RICHEditor.styles = {};
RICHEditor.editorDiv = document.getElementById('editor');
RICHEditor.editor = new Squire(RICHEditor.editorDiv, {
    blockTag: 'div',
    blockAttributes: {'class': 'paragraph'},
    tagAttributes: {
        ul: {'class': 'UL'},
        ol: {'class': 'OL'},
        li: {'class': 'listItem'},
        a: {'target': '_blank'},
        pre: {
            style: 'border-radius:3px;border:1px solid #ccc;padding:7px 10px;background:#f6f6f6;font-family:menlo,consolas,monospace;font-size:90%;white-space:pre-wrap;word-wrap:break-word;overflow-wrap:break-word;'
        },
        code: {
            style: 'border-radius:3px;border:1px solid #ccc;padding:1px 3px;background:#f6f6f6;font-family:menlo,consolas,monospace;font-size:90%;'
        },
    }
});
Squire.prototype.makeHeader = function () {
    return this.modifyBlocks(function (frag) {
        var output = this._doc.createDocumentFragment();
        var block = frag;
        while (block = Squire.getNextBlock(block)) {
            output.appendChild(
                this.createElement('h2', [Squire.empty(block)])
            );
        }
        return output;
    });
};

RICHEditor.undo = function () {
    RICHEditor.editor.undo();
}

RICHEditor.redo = function () {
    RICHEditor.editor.redo();
}

RICHEditor.setPlaceholder = function (placeholder) {
    $('#placeholder').text(placeholder);
    RICHEditor.placeholder();
}

RICHEditor.setBold = function () {
    if (!document.queryCommandState('bold')) {
        RICHEditor.editor.bold();
    } else {
        RICHEditor.editor.removeBold();
    }
    RICHEditor.enabledEditingItems();
};

RICHEditor.removeBold = function () {
    RICHEditor.editor.removeBold();
    RICHEditor.enabledEditingItems();
};

RICHEditor.setItalic = function () {
    if (!document.queryCommandState('italic')) {
        RICHEditor.editor.italic();
    } else {
        RICHEditor.editor.removeItalic();
    }
    RICHEditor.enabledEditingItems();
};

RICHEditor.removeItalic = function () {
    RICHEditor.editor.removeItalic();
    RICHEditor.enabledEditingItems();
};

RICHEditor.setUnderline = function () {
    if (!document.queryCommandState('underline')) {
        RICHEditor.editor.underline();
    } else {
        RICHEditor.editor.removeUnderline();
    }
    RICHEditor.enabledEditingItems();
};

RICHEditor.removeUnderline = function () {
    RICHEditor.editor.removeUnderline();
    RICHEditor.enabledEditingItems();
};

RICHEditor.setStrikeThrough = function () {
    if (!document.queryCommandState('strikethrough')) {
        RICHEditor.editor.strikethrough();
    } else {
        RICHEditor.editor.removeStrikethrough();
    }
    RICHEditor.enabledEditingItems();
};

RICHEditor.removeStrikethrough = function () {
    RICHEditor.editor.removeStrikethrough();
    RICHEditor.enabledEditingItems();
};

RICHEditor.setBackgroundColor = function () {
    if (document.queryCommandValue('backColor').toLowerCase() === 'rgb(252, 239, 164)') {
        RICHEditor.editor.setHighlightColour();
    } else {
        RICHEditor.editor.setHighlightColour('#fcefa4');
    }
    RICHEditor.enabledEditingItems();
}

RICHEditor.setTextColor = function (color) {
    RICHEditor.editor.setTextColour(color);
    RICHEditor.enabledEditingItems();
}

RICHEditor.setFontSize = function (fontSize) {
    RICHEditor.cursorHeight = fontSize;
    RICHEditor.editor.setFontSize(fontSize);
    RICHEditor.enabledEditingItems();
}

RICHEditor.setJustifyLeft = function () {
    RICHEditor.editor.setTextAlignment('left');
    RICHEditor.enabledEditingItems();
};

RICHEditor.setJustifyCenter = function () {
    RICHEditor.editor.setTextAlignment('center');
    RICHEditor.enabledEditingItems();
};

RICHEditor.setJustifyRight = function () {
    RICHEditor.editor.setTextAlignment('right');
    RICHEditor.enabledEditingItems();
};

RICHEditor.setOrderedList = function () {
    if (!document.queryCommandState('insertOrderedList')) {
        RICHEditor.editor.makeOrderedList();
    } else {
        RICHEditor.editor.removeList();
    }
    RICHEditor.placeholder();
    RICHEditor.enabledEditingItems();
};

RICHEditor.setUnorderedList = function () {
    if (!document.queryCommandState('insertUnorderedList')) {
        RICHEditor.editor.makeUnorderedList();
    } else {
        RICHEditor.editor.removeList();
    }
    RICHEditor.placeholder();
    RICHEditor.enabledEditingItems();
};

RICHEditor.setIndent = function () {
    document.execCommand('indent', false, null);
    RICHEditor.enabledEditingItems();
};

RICHEditor.setOutdent = function () {
    document.execCommand('outdent', false, null);
    RICHEditor.enabledEditingItems();
};

RICHEditor.setTodo = function () {
    if (!document.queryCommandState('insertUnorderedList')) {
        RICHEditor.editor.makeUnorderedList();
    } else {
        RICHEditor.editor.removeList();
    }
    RICHEditor.TAG = "TODO";
    RICHEditor.placeholder();
    RICHEditor.getHtml('inputHtml');
}

RICHEditor.removeProgress= function(){
   $(".upload-progress").remove();
}

RICHEditor.setNoteUpload = function(imgId) {
   var obj = $('#img-div-' + imgId);
   if (obj) {
       obj.append('<div class="upload-progress" contenteditable="false" id="upload-progress-' + imgId + '"><div class="load-bar" id="progressd-bar-' + imgId + '"><div class="load-bar-inner" id="progress-' + imgId + '"></div></div></div>');
       RICHEditor.setUploadFail(imgId);
   }
}

RICHEditor.setUploadFail = function(imgId){
   var bar = $("#progressd-bar-" + imgId);
   if (bar) {
       bar.hide();
   }
   var obj = $("#upload-progress-" + imgId);
   if (obj) {
       var uploadHtml = obj.html();
       if (uploadHtml.indexOf("upload-fail") < 0) {
          obj.append('<div class="upload-fail" id="upload-fail-' + imgId + '"><span class="iconfont icon-reset opre-btn" id="img-upload-' + imgId + '"></span><br/> <span>上传失败，请重试</span></div>');
       } else {
          $("#upload-fail-" + imgId).show();
       }
       initOpre();
   }
}

RICHEditor.setUploadProgress = function(imgId, progress, backgroundColor){
    var obj = $("#progress-" + imgId);
    if (obj) {
        obj.width(progress + '%');
        if (!obj[0].style.backgroundColor && backgroundColor) {
            obj[0].style.backgroundColor = backgroundColor;
        }
        if (parseFloat(progress) > 99.9) {
           $("#upload-progress-" + imgId).remove();
           RICHEditor.getHtml('inputHtml');
        }
    }
}

RICHEditor.insertImage = function (url, imgId, alt, upload) {
    var txt = $('#editor').text();
    var edithtml = $('#editor').html();
    var html;
    if (isNotEmpty(txt) || edithtml.indexOf('<img') > -1 || edithtml.indexOf('<input') > -1 || edithtml.indexOf('<ol') > -1 || edithtml.indexOf('<ul') > -1) {
        html = '<div class="paragraph"></div><div class="img-wap-cover paragraph" id="img-div-' + imgId + '"><img class="img-wap" src="' + url + '" id="img-' + imgId + '"';
    } else {
        html = '<div class="img-wap-cover paragraph" id="img-div-' + imgId + '"><img class="img-wap" src="' + url + '" id="img-' + imgId + '"';
    }
    if (alt) {
        html += ' alt="' + alt;
    }
    html += '"/>';
    if (parseInt(upload) === 1) {
       html += '<div class="upload-progress" contenteditable="false" id="upload-progress-' + imgId + '"><div class="load-bar" id="progressd-bar-' + imgId + '"><div class="load-bar-inner" id="progress-' + imgId + '"></div></div></div>';
    }
    html += '</div><div class="paragraph"></div>';
    RICHEditor.insertHTML(html);
    RICHEditor.placeholder();
    RICHEditor.getHtml('inputHtml');
};

RICHEditor.setImage = function (url, imgId, newImgId) {
    $("#img-" + imgId).attr('src', url);
    $("#img-" + imgId).attr('alt', newImgId);
    $('#img-' + imgId).attr('id', 'img-' + newImgId);
    $('#img-div-' + imgId).attr('id', 'img-div-' + newImgId);
    $('#img-btn-' + imgId).attr('id', 'img-btn-' + newImgId);
    $('#img-edit-' + imgId).attr('id', 'img-edit-' + newImgId);
    $('#img-del-' + imgId).attr('id', 'img-del-' + newImgId);
    $('#img-div-' + newImgId + ' .upload-progress').remove();
    // $('#img-div-' + newImgId).append('<div class="upload-progress" contenteditable="false" id="upload-progress-' + newImgId + '"><div class="load-bar" id="progressd-bar-' + newImgId + '"><div class="load-bar-inner" id="progress-' + newImgId + '"></div></div></div>');
    RICHEditor.getHtml('inputHtml');
}

RICHEditor.imgClick = function (e) {
    $("#editor").attr("contentEditable", false);
    RICHEditor.editor.blur();
    id = e.id;
    $(".img-wap-btn").remove();
    if (RICHEditor.imgId && id != RICHEditor.imgId) {
        id = RICHEditor.imgId;
    }
    if (id.indexOf("img-") < 0) {
        $("img").removeClass('img-blur');
        RICHEditor.executeCallback('img-ban', true);
        RICHEditor.setEditable();
        return;
    }
    var bid = id.replace('img', 'img-btn');
    var did = id.replace('img', 'img-div');
    var imgEditId = id.replace('img', 'img-edit');
    var imgDelId = id.replace('img', 'img-del');
    var dhtml = $("#" + did).html();
    if (!dhtml) {
        $("img").removeClass('img-blur');
        RICHEditor.executeCallback('img-ban', true);
        RICHEditor.setEditable();
        return;
    }
    if (dhtml.indexOf('img-wap-btn') < 0) {
        $("#" + did).append('<div contenteditable="false" class="img-wap-btn" id="' + bid + '"><span class="iconfont icon-edit opre-btn" id="' + imgEditId + '"></span><span class="iconfont icon-delete opre-btn" id="' + imgDelId + '"></span></div>');
        initOpre();
    } else {
        $("#" + bid).attr("contentEditable", false);
        initOpre();
    }
    $("#" + bid).css("top", $("#" + id).height() / 2 - 40);
    if ($("#" + id).hasClass('img-blur')) {
        $("#" + id).removeClass('img-blur');
        $("#" + bid).remove();
    } else {
        $("img").removeClass('img-blur');
        $("#" + id).addClass('img-blur');
        $("#" + bid).show();
    }
    RICHEditor.setEditable();
}

function initOpre() {
    $(".opre-btn").unbind("click");
    $(".opre-btn").click(function () {
        var id = $(this).attr("id");
        $("#editor").attr("contentEditable", false);
        if (id.indexOf('img-del') > -1) {
            var did = id.replace('img-del', 'img-div');
            $("#" + did).remove();
            RICHEditor.executeCallback('img-del', id);
            RICHEditor.getHtml('inputHtml');
        } else if (id.indexOf('img-edit') > -1) {
            var bid = id.replace('img-edit', 'img-btn');
            var imgid = id.replace('img-edit', 'img');
            $("#" + imgid).removeClass('img-blur')
            $("#" + bid).remove();
            var edit = {id:id,imgUrl:$("#"+imgid)[0].src};
            RICHEditor.executeCallback('img-edit', JSON.stringify(edit));
        } else if (id.indexOf('img-upload') > -1) {
            var fid = id.replace('img-upload', 'upload-fail');
            var pid = id.replace('img-upload', 'progressd-bar');
            $("#" + fid).remove();
            $("#" + pid).show();
            RICHEditor.executeCallback('img-upload', id);
        }
        RICHEditor.setEditable();
    });
}

RICHEditor.removeEdit = function () {
    $("img").removeClass('img-blur');
    $(".img-wap-btn").remove();
}

RICHEditor.setEditable = function () {
    window.setTimeout(function () {
        RICHEditor.imgId = null;
        $("#editor").attr("contentEditable", true);
    }, 500);
};

RICHEditor.insertHTML = function (html) {
    html = getgetEscapeHtml(html);
    RICHEditor.editor.insertHTML(html);
    RICHEditor.placeholder();
}

RICHEditor.scrollTop = function () {
    $('body,html').animate({
        scrollTop: 0
    }, 0);
}

RICHEditor.insertText = function (text, top) {
    text = getgetEscapeStr(text);
    RICHEditor.editor.insertPlainText(text);
    RICHEditor.placeholder();
    if (parseInt(top) === 1) {
       RICHEditor.scrollTop();
    }
}

RICHEditor.setHTML = function (html) {
    $("#editor").attr("contentEditable", false);
    html = getgetEscapeHtml(html);
    RICHEditor.editor.setHTML(html);
    RICHEditor.setEditable();
    RICHEditor.placeholder();
    RICHEditor.getHtml('setHTML');
    RICHEditor.scrollTop();
}

RICHEditor.getHtml = function (type) {
    var html = $('#editor').html();
    $("#editor-save").html(html);
    $("#editor-save .upload-progress").remove();
    $("#editor-save img").removeClass('img-blur');
    $("#editor-save .img-wap-btn").remove();
    html =  $("#editor-save").html();
    html = html.replace(/[\r\n]/g,"<br>");
    RICHEditor.executeCallback(type, html);
    $("#editor-save").html("");
}

RICHEditor.placeholder = function () {
    var txt = $('#editor').text();
    var html = $('#editor').html();
    var start = 0;
    html.replace(/<br>/g,function () {
       start++;
    });
    if (isNotEmpty(txt) || html.indexOf('<img') > -1 || html.indexOf('<input') > -1 || html.indexOf('<ol') > -1 || html.indexOf('<ul') > -1 || start > 1) {
       $('#placeholder').css('display', 'none');
    } else {
       $('#placeholder').css('display', '');
    }
}

function getgetEscapeStr(str) {
    str = str.replace(/&backslash;/g, "\\");
    str = str.replace(/&singlequotes;/g, "'");
    return str;
}

function getgetEscapeHtml(html) {
    html = html.replace(/&backslash;/g, "\\");
    return html;
}

function isNotEmpty(str) {
    if (str != null && str.length > 0) {
        return true;
    }
    return false;
}



RICHEditor.enabledEditingItems = function () {
    RICHEditor.styles.fontSize = parseInt(document.queryCommandValue('fontSize'));
    RICHEditor.cursorHeight = RICHEditor.styles.fontSize;
    RICHEditor.styles.textColor = document.queryCommandValue('foreColor');
    RICHEditor.styles.backColor = document.queryCommandValue('backColor');
    RICHEditor.styles.bold = document.queryCommandState('bold');
    RICHEditor.styles.italic = document.queryCommandState('italic');
    RICHEditor.styles.strikeThrough = document.queryCommandState('strikeThrough');
    RICHEditor.styles.underline = document.queryCommandState('underline');
    RICHEditor.styles.insertOrderedList = document.queryCommandState('insertOrderedList');
    RICHEditor.styles.insertUnorderedList = document.queryCommandState('insertUnorderedList');
    RICHEditor.styles.justifyCenter = document.queryCommandState('justifyCenter');
    RICHEditor.styles.justifyLeft = document.queryCommandState('justifyLeft');
    RICHEditor.styles.justifyRight = document.queryCommandState('justifyRight');
    RICHEditor.executeCallback('styles', JSON.stringify(RICHEditor.styles));
    RICHEditor.getHtml('inputHtml');
}

// 导出
RICHEditor.export = function(contentType, srcs, fontJs) {
    if (srcs) {
        ExportObj.base64Srcs = JSON.parse(srcs);
    }
    var html = $('#editor').html();
    $("#editor-save").html(html);
    $("#editor-save .upload-progress").remove();
    $("#editor-save img").removeClass('img-blur');
    $("#editor-save .img-wap-btn").remove();
    html =  $("#editor-save").html();
    ExportObj.editorHtml = ExportObj.startHtml + html + ExportObj.endHtml;
    ExportObj.initObj(contentType);
    var obj = $("#editor-save").children();
    if (obj.length > 0) {
        ExportObj.childrenLists(obj,ExportObj.index);
    }

    ExportObj.analysisContent();
    if (contentType === 'application/msword') {
        try {
            ExportObj.Docx.generate().then(function (converted) {
                var blobUrl =  URL.createObjectURL(converted);
                getBase64StringFromBlobUrl(blobUrl, contentType);
            });
        } catch (e) {
            RICHEditor.executeCallback(contentType, 'error');
            RICHEditor.exportErr(e);
        }
    } else if (contentType === 'application/pdf') {
        var docDefinition = {
            pageSize: 'A4',
            content: ExportObj.pdfContent,
            defaultStyle: {
                font: 'china'
            }
        };
        try {
            fontJs = fontJs ? fontJs : 'js/china_vfs_fonts.js';
            loadScript(fontJs ,function () {
                pdfMake.createPdf(docDefinition).getBase64(function(base64data){
                    RICHEditor.executeCallback(contentType, base64data);
                });
            });
        } catch (e) {
            RICHEditor.executeCallback(contentType, 'error');
            RICHEditor.exportErr(e);
        }
    }
    $("#editor-save").html("");
}

RICHEditor.exportErr = function (e) {
    var errData = {};
    errData.name = e.name;
    errData.message = e.message;
    errData.fileName = e.fileName;
    errData.lineNumber = e.lineNumber;
    errData.stack = e.stack;
    errData.description = e.description;
    RICHEditor.executeCallback('export-err', JSON.stringify(errData));
}

function loadScript(url, callback) {
    var scripts = document.getElementsByTagName('script');
    var len = scripts.length;
    for (var i = 0; i < len; i++) {
        if (scripts[i].src.endsWith(url)) {
            callback();
            return;
        }
    }
    var script = document.createElement("script");
    script.type = "text/javascript";
    if (typeof(callback) != "undefined") {
        if (script.readyState) {
            script.onreadystatechange = function() {
                if (script.readyState == "loaded" || script.readyState == "complete") {
                    script.onreadystatechange = null;
                    callback();
                }
            };
        } else {
            script.onload = function() {
                callback();
            };
        }
    };
    script.src = url;
    document.body.appendChild(script);
}

// BlobUrl转Base64
function getBase64StringFromBlobUrl(blobUrl, contentType) {
    var xhr = new XMLHttpRequest();
    xhr.open('GET', blobUrl, true);
    xhr.setRequestHeader('Content-type', contentType);
    xhr.responseType = 'blob';
    xhr.onload = function (e) {
        if (this.status == 200) {
            var blobByte = this.response;
            var reader = new FileReader();
            reader.readAsDataURL(blobByte);
            reader.onloadend = function () {
                var base64data = reader.result;
//                base64data = base64data.replace("data:application/vnd.openxmlformats-officedocument.wordprocessingml.document;base64,","");
                base64data = base64data.substr(base64data.indexOf(',') + 1);
                RICHEditor.executeCallback(contentType, base64data);
            }
        }
    }
    xhr.send();
}

RICHEditor.executeCallback = function (callbackId, params) {
     EQ.executeCallback(callbackId,params);
    // var body = {callbackId:callbackId,body:params};
    // window.webkit.messageHandlers.EQ.postMessage(body);
}
