
//buffer 转 Base64
function bufferToBase64(buffer) {
    var binary = '';
    var bytes = new Uint8Array(buffer);
    var len = bytes.byteLength;
    for (var i = 0; i < len; i++) {
        binary += String.fromCharCode(bytes[i]);
    }
    return window.btoa(binary);
}

function base64Encode (str) {
    return btoa(encodeURIComponent(str));
}

function base64Decode (str) {
    return decodeURIComponent(atob(str));
}

//Base64 转 buffer
function base64ToBuffer(base64String) {
    var padding = '='.repeat((4 - base64String.length % 4) % 4);
    var base64 = (base64String + padding)
        .replace(/\-/g, '+')
        .replace(/_/g, '/');

    var rawData = window.atob(base64);
    var outputArray = new Uint8Array(rawData.length);

    for (var i = 0; i < rawData.length; ++i) {
        outputArray[i] = rawData.charCodeAt(i);
    }
    return outputArray;
}

/**
 * 处理单元格字符串
 */
function changeCellStr(str) {
    str = str.replace(/&enter;/g, "\r\n");
    return str;
}

/**
 * 处理Json字符串
 */
function changeJsonStr(str) {
    str = str.replace(/[\r]/g, "\\r").replace(/[\n]/g, "\\n");
    return str;
}

//获取当前时间戳
function getTime() {
    return parseInt((new Date().getTime()) / 1000);
}

/**
 * 获取毫秒
 */
function getTimeMilliSecond() {
    return new Date().getTime();
}

function isPhone() {
    if((navigator.userAgent.match(/(phone|pad|pod|iPhone|iPod|ios|iPad|Android|Mobile|BlackBerry|IEMobile|MQQBrowser|JUC|Fennec|wOSBrowser|BrowserNG|WebOS|Symbian|Windows Phone)/i))) {
        return true;
    }
    return false;
}


//获取标准颜色
function getExcelJsColor(color) {
    fcArr = color.split();
    var color = '';
    fcArr.forEach(function (item) {
        color = color + item + item;
    });
    console.log('color:' + color);
    return color;
}

//颜色转十六进制
function colorRGBtoHex(color) {
    var rgb = color.split(',');
    if (color.trim().toUpperCase().indexOf("RGB") > -1 || color.trim().toUpperCase().indexOf("RGBA") > -1) {
        var r = parseInt(rgb[0].split('(')[1]);
        var g = parseInt(rgb[1]);
        var b;
        if (color.trim().toUpperCase().indexOf("RGBA") > -1) {
            b = parseInt(rgb[2]);
        } else {
            b = parseInt(rgb[2].split(')')[0]);
        }
        var hex = ((1 << 24) + (r << 16) + (g << 8) + b).toString(16).slice(1);
        return hex;
    }
    return '';
}


